/**
  *  \file testiter.cc
  */

#include <vector>
#include <iostream>
#include <map>
#include "cpluslib/iterator.h"


int main()
{
    std::vector<int*> pvec;
    pvec.push_back(new int(1));
    pvec.push_back(new int(2));
    pvec.push_back(new int(3));
    pvec.push_back(new int(17));
    pvec.push_back(new int(42));
    pvec.push_back(new int(-1));

    std::cout << "-- pointer iterator:\n";
    typedef dereferencing_iterator<std::vector<int*>::iterator> ite;
    for (ite i = ite(pvec.begin()); i != ite(pvec.end()); ++i)
        std::cout << *i << "\n";

    std::map<int,int*> imap;
    imap[1] = new int(17);
    imap[17] = new int(42);
    imap[42] = new int(3);

    std::cout << "-- member iterator:\n";
    typedef member_iterator<std::map<int,int*>::iterator,
                            const int,
                            &std::pair<const int,int*>::first> mite;
    for (mite i = mite(imap.begin()); i != mite(imap.end()); ++i)
        std::cout << *i << "\n";

    std::cout << "-- member iterator + pointer iterator:\n";
    typedef dereferencing_iterator<member_iterator<std::map<int,int*>::iterator,
                                                   int*,
                                                   &std::pair<const int,int*>::second> > dite;
    for (dite i = dite(imap.begin()); i != dite(imap.end()); ++i)
        std::cout << *i << "\n";

    return 0;
}
